local badeline = nil

local function badeline_appears(left_side)
  local pos_x, scale
  if left_side then
    pos_x = player.Position.X - 25
    scale = 1
  else
    pos_x = player.Position.X + 25
    scale = -1
  end
  local pos_y = player.Position.Y - 8

  badeline = celeste.BadelineDummy(vector2(pos_x, pos_y))
  badeline.Sprite.Scale = vector2(scale, 1.0)
  getLevel():Add(badeline)

  getLevel().Displacement:AddBurst(badeline.Center, 0.5, 8, 32, 0.5)
  playSound("event:/char/badeline/maddy_split", badeline.Position)

  wait(1)
end

local function badeline_vanishes()
  badeline:Vanish()
  celeste.Input.Rumble(getEnum("Celeste.RumbleStrength", "Medium"), getEnum("Celeste.RumbleLength", "Medium"))
  badeline = nil

  wait()
end

function onBegin()
  local player = getEntity("Player")
  player.speed = 0
	disableMovement()
	waitUntilOnGround()
	badeline_appears(true)
	say("view_dialog")
	badeline_vanishes()
end

function onEnd()
	if badeline then
		badeline:RemoveSelf()
		badeline = nil
	end
	enableMovement()
end